{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": null,
            "arguments": [
                "output.dir=$(runtime.outdir)"
            ],
            "hints": [
                {
                    "dockerPull": "ibisba/retropath2:latest",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "input.cofsfile=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.cofsfile"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "input.dmax=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.dmax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "input.dmin=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.dmin"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "input.max-steps=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.max-steps"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "input.mwmax-cof=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.mwmax-cof"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "input.mwmax-source=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.mwmax-source"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "input.rulesfile=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.rulesfile"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "input.sinkfile=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.sinkfile"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "input.sourcefile=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.sourcefile"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "input.std_mode=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.std_mode"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "input.stereo_mode=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.stereo_mode"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "input.topx=",
                        "separate": false
                    },
                    "id": "#RetroPath2.cwl/input.topx"
                }
            ],
            "stdout": "output.txt",
            "id": "#RetroPath2.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "results.csv"
                    },
                    "id": "#RetroPath2.cwl/solutionfile"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "source-in-sink.csv"
                    },
                    "id": "#RetroPath2.cwl/sourceinsinkfile"
                },
                {
                    "type": "File",
                    "id": "#RetroPath2.cwl/stdout",
                    "outputBinding": {
                        "glob": "output.txt"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "RP2paths.py",
                "all"
            ],
            "hints": [
                {
                    "dockerPull": "ibisba/rp2paths",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "version": [
                                "1.0.0",
                                "1.0.1",
                                "1.0.2"
                            ],
                            "package": "rp2paths"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "doc": "Extract paths from RetroPath 2.0 output\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "File with name of compounds.",
                    "inputBinding": {
                        "prefix": "--cmpdnamefile"
                    },
                    "id": "#rp2paths.cwl/cmpdnamefile"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "User-defined sink file, i.e. file listing compounds to consider as sink compounds.  Sink compounds should be provided by their IDs, as used in the reaction.erxn file.  If no file is provided then the sink file generated during the \"convert\" task is  used (default behavior). If a file is provided then **only** comppounds listed  in this file will be used.\n",
                    "inputBinding": {
                        "prefix": "--customsinkfile"
                    },
                    "id": "#rp2paths.cwl/customsinkfile"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "Binary that enumerate the EFMs",
                    "inputBinding": {
                        "prefix": "--ebin"
                    },
                    "id": "#rp2paths.cwl/ebin"
                },
                {
                    "type": "File",
                    "doc": "RetroPath file as outputed by the RetroPath2.0 workflow",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#rp2paths.cwl/infile"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 150,
                    "doc": "cutoff on the maximum number of pathways",
                    "inputBinding": {
                        "prefix": "--maxpaths"
                    },
                    "id": "#rp2paths.cwl/maxpaths"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 10,
                    "doc": "cutoff on the maximum number of steps in a pathways",
                    "inputBinding": {
                        "prefix": "--maxsteps"
                    },
                    "id": "#rp2paths.cwl/maxsteps"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use minimal depth scope, i.e. stop the scope computation as as soon an a first  minimal path linking target to sink is found (default - False).\n",
                    "inputBinding": {
                        "prefix": "--minDepth"
                    },
                    "id": "#rp2paths.cwl/minDepth"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "List of compounds IDs. If specifed, paths making use of  one of these compounds as unique initial substrate will  be filtered out\n",
                    "inputBinding": {
                        "prefix": "--notPathsStartingBy"
                    },
                    "id": "#rp2paths.cwl/notPathsStartingBy"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "List of compounds IDs to consider. If specified, only paths making use of  at least one of these compounds as initial substrate (first step of a pathway) are kept.\n",
                    "inputBinding": {
                        "prefix": "--onlyPathsStartingBy"
                    },
                    "id": "#rp2paths.cwl/onlyPathsStartingBy"
                },
                {
                    "type": "boolean",
                    "doc": "Consider reactions in the reverse direction",
                    "inputBinding": {
                        "prefix": "--reverse"
                    },
                    "id": "#rp2paths.cwl/reverse"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Target compound internal ID. This internal ID specifies which compound  should be considered as the targeted compound. The default behavior is  to consider as the target the first compound used as a source compound  in a first iteration of a metabolic exploration. Let this value as it  is except if you know what you are doing.\n",
                    "inputBinding": {
                        "prefix": "--target"
                    },
                    "id": "#rp2paths.cwl/target"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 900,
                    "doc": "Timeout before killing a process (in s)",
                    "inputBinding": {
                        "prefix": "--timeout"
                    },
                    "id": "#rp2paths.cwl/timeout"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Unfold pathways based on equivalencie of compounds (can lead to combinatorial explosion).",
                    "inputBinding": {
                        "prefix": "--unfold_compounds"
                    },
                    "id": "#rp2paths.cwl/unfold_compounds"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "compounds.txt"
                    },
                    "doc": "A list of compounds\n",
                    "id": "#rp2paths.cwl/compounds"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "reactions.erxn"
                    },
                    "doc": "A list of reactions  # which format?\n",
                    "id": "#rp2paths.cwl/reactions"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "sinks.txt"
                    },
                    "doc": "A list of sinks\n",
                    "id": "#rp2paths.cwl/sinks"
                }
            ],
            "id": "#rp2paths.cwl"
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/max-steps"
                },
                {
                    "type": "boolean",
                    "id": "#main/reverse"
                },
                {
                    "type": "File",
                    "id": "#main/rulesfile"
                },
                {
                    "type": "File",
                    "id": "#main/sinkfile"
                },
                {
                    "type": "File",
                    "id": "#main/sourcefile"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/rp2paths/compounds",
                    "id": "#main/compounds"
                },
                {
                    "type": "File",
                    "outputSource": "#main/rp2paths/reactions",
                    "id": "#main/reactions"
                },
                {
                    "type": "File",
                    "outputSource": "#main/rp2paths/sinks",
                    "id": "#main/sinks"
                }
            ],
            "steps": [
                {
                    "run": "#RetroPath2.cwl",
                    "in": [
                        {
                            "source": "#main/max-steps",
                            "id": "#main/rp2/input.max-steps"
                        },
                        {
                            "source": "#main/rulesfile",
                            "id": "#main/rp2/input.rulesfile"
                        },
                        {
                            "source": "#main/sinkfile",
                            "id": "#main/rp2/input.sinkfile"
                        },
                        {
                            "source": "#main/sourcefile",
                            "id": "#main/rp2/input.sourcefile"
                        }
                    ],
                    "out": [
                        "#main/rp2/solutionfile"
                    ],
                    "id": "#main/rp2"
                },
                {
                    "run": "#rp2paths.cwl",
                    "in": [
                        {
                            "source": "#main/rp2/solutionfile",
                            "id": "#main/rp2paths/infile"
                        },
                        {
                            "source": "#main/reverse",
                            "id": "#main/rp2paths/reverse"
                        }
                    ],
                    "out": [
                        "#main/rp2paths/compounds",
                        "#main/rp2paths/reactions",
                        "#main/rp2paths/sinks"
                    ],
                    "id": "#main/rp2paths"
                }
            ],
            "hints": [
                {
                    "dependencies": [
                        {
                            "upstream": "https://raw.githubusercontent.com/ibisba/RetroPath2-cwl/0.0.1/tools/RetroPath2.cwl",
                            "installTo": "../tools/RetroPath2"
                        },
                        {
                            "upstream": "https://raw.githubusercontent.com/ibisba/rp2paths-cwl/1.0.2-1/tools/rp2paths.cwl",
                            "installTo": "../tools/rp2paths"
                        }
                    ],
                    "class": "http://commonwl.org/cwldep#Dependencies"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "dep": "http://commonwl.org/cwldep#"
    }
}
